public Action:Event_PlayerHurt(Handle:event, String:event_name[], bool:dontBroadcast)
{
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	new victim = GetClientOfUserId(GetEventInt(event, "userid"));

	//CheckLoadAttemptEveryone();
	if (IsClientHuman(attacker) && !bRoundOver && !bLoadAttempted[attacker])
	{
		bLoadAttempted[attacker] = true;
		IsLoading[attacker] = true;
		LoadPlayerData(attacker);
		return;
	}
	if (IsClientHuman(attacker) && !IsLoading[attacker] && IsClientActual(victim) && GetClientTeam(attacker) != GetClientTeam(victim))
	{
		new damage = GetEventInt(event, "dmg_health");
		if (GetClientTeam(attacker) == TEAM_SURVIVORS) SurvivorDamage[attacker] += damage;
		else if (GetClientTeam(attacker) == TEAM_INFECTED) InfectedDamage[attacker] += damage;
	}
}

public Action:Event_InfectedDeath(Handle:event, String:event_name[], bool:dontBroadcast)
{
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));

	if (IsClientHuman(attacker) && GetClientTeam(attacker) == TEAM_SURVIVORS)
	{
		if (!bRoundOver && !bLoadAttempted[attacker])
		{
			bLoadAttempted[attacker] = true;
			IsLoading[attacker] = true;
			LoadPlayerData(attacker);
			return;
		}
		if (!IsLoading[attacker]) CommonKills[attacker]++;
	}
}

public Action:Event_PlayerIncapacitated(Handle:event, String:event_name[], bool:dontBroadcast)
{
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	new victim = GetClientOfUserId(GetEventInt(event, "userid"));

	if (IsClientActual(attacker) && !IsLoading[attacker] && IsClientHuman(victim) && GetClientTeam(attacker) != GetClientTeam(victim))
	{
		SurvivorIncaps[victim]++;
		InfectedIncaps[attacker]++;
	}
}

public Action:Event_ChokeStopped(Handle:event, String:event_name[], bool:dontBroadcast)
{
	new savior = GetClientOfUserId(GetEventInt(event, "userid"));
	new type = GetEventInt(event, "release_type");
	if (type != 4 && type != 2) return;

	if (IsClientHuman(savior) && !IsLoading[savior])
	{
		Rescues[savior]++;
	}
}

public Action:Event_JockeyRideEnd(Handle:event, String:event_name[], bool:dontBroadcast)
{
	new savior = GetClientOfUserId(GetEventInt(event, "rescuer"));
	new client = GetClientOfUserId(GetEventInt(event, "victim"));
	if (IsClientHuman(savior) && !IsLoading[savior])
	{
		Rescues[savior]++;
	}
	if (IsClientHuman(client)) bEnsnared[client] = false;
}

public Action:Event_PounceStopped(Handle:event, String:event_name[], bool:dontBroadcast)
{
	new savior = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if (IsClientHuman(savior) && !IsLoading[savior])
	{
		Rescues[savior]++;
	}
}

public Action:Event_ReviveSuccess(Handle:event, String:event_name[], bool:dontBroadcast)
{
	new savior = GetClientOfUserId(GetEventInt(event, "userid"));
	new subject = GetClientOfUserId(GetEventInt(event, "subject"));
	
	if (IsClientHuman(savior) && !IsLoading[savior] && IsClientActual(subject) && savior != subject)
	{
		Rescues[savior]++;
	}
}

public Action:Event_EnsnareBegin(Handle:event, String:event_name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "victim"));
	
	if (IsClientHuman(client)) bEnsnared[client] = true;
}

public Action:Event_EnsnareEnd(Handle:event, String:event_name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "victim"));
	
	if (IsClientHuman(client)) bEnsnared[client] = false;
}

public Action:OnTakeDamage(victim, &attacker, &inflictor, &Float:damage, &damagetype)
{
	if (IsClientHuman(attacker) && IsClientActual(victim) && GetClientTeam(attacker) == GetClientTeam(victim) && !bRoundOver)
	{
		if ((GetClientTeam(attacker) == TEAM_SURVIVORS && GetConVarInt(g_Control_FriendlyFireLimit[0]) > 0 || GetClientTeam(attacker) == TEAM_INFECTED && GetConVarInt(g_Control_FriendlyFireLimit[1]) > 0) &&
			attacker != victim && !bEnsnared[victim])
		{
			FriendlyFire[attacker] += RoundToFloor(damage);
			if (!bCFF[attacker]) CheckFriendlyFireResponse(attacker);
		}
		if (GetConVarInt(g_Control_FriendlyFire) == 1)
		{
			damage = 0.0;
			SetEntityHealth(attacker, GetClientHealth(attacker) - GetConVarInt(g_Control_FriendlyFire_PenaltyAmount));
			return Plugin_Changed;
		}
	}
	return Plugin_Continue;
}

public CheckFriendlyFireResponse(client)
{
	if (GetConVarInt(g_Control_FriendlyFireResponse) == 1 &&
		(GetClientTeam(client) == TEAM_SURVIVORS && FriendlyFire[client] >= GetConVarInt(g_Control_FriendlyFireLimit[0]) || GetClientTeam(client) == TEAM_INFECTED && FriendlyFire[client] >= GetConVarInt(g_Control_FriendlyFireLimit[1])))
	{
		new String:Name[MAX_NAME_LENGTH];
		GetClientName(client, Name, sizeof(Name));
		PrintToChatAll("%t","Kicked Due To Friendly Fire", green, white, orange, Name);
	
		new String:text[128];
		Format(text, sizeof(text), "%T", "Friendly Fire Violation", client);
		if (GetConVarInt(g_Control_FriendlyFireResponse) == 1)
		{
			LogToFile(LOGFILE, "%s was Kicked from the server due to friendly fire violations.", Name);
			KickClient(client, "%s", text);
		}
		else if (GetConVarInt(g_Control_FriendlyFireResponse) == 2)
		{
			LogToFile(LOGFILE, "%s was Banned from the server due to friendly fire violations. (%d Minutes)", Name, RoundToFloor(GetConVarFloat(g_Control_FriendlyFireBanTime)));
			new Float:time = GetConVarFloat(g_Control_FriendlyFireBanTime);
			ServerCommand("sm_ban %d %d %s", client, RoundToCeil(time), text);
		}
	}
	bCFF[client]	=	false;
}